package epsilonStandalone;

import com.google.common.base.Objects;
import epsilonStandalone.DNIRunner;
import epsilonStandalone.ExperimentModel;
import java.io.BufferedReader;
import java.io.FileReader;
import java.util.Collections;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import org.eclipse.epsilon.eol.execute.context.Variable;
import org.eclipse.epsilon.eol.types.EolPrimitiveType;
import org.eclipse.xtext.xbase.lib.CollectionLiterals;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.InputOutput;
import org.eclipse.xtext.xbase.lib.IntegerRange;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure2;

@SuppressWarnings("all")
public class DNIRunner_mk_old extends DNIRunner {
  public static void main(final String[] args) {
    final DNIRunner_mk_old a = new DNIRunner_mk_old();
    a.reset();
    a.start_experiment1(true);
  }
  
  public String reset() {
    String _xblockexpression = null;
    {
      LinkedList<String> _newLinkedList = CollectionLiterals.<String>newLinkedList("SW40_i_SW00_rx", "SW40_i_SW00_tx", 
        "SW41_i_SW00_rx", "SW41_i_SW00_tx", 
        "SW41_i_C12_rx", "SW41_i_C12_tx", 
        "SW41_i_C13_rx", "SW41_i_C13_tx", 
        "SW42_i_SW00_rx", "SW42_i_SW00_tx", 
        "SW42_i_C17_rx", "SW42_i_C17_tx", 
        "SW42_i_C36_rx", "SW42_i_C36_tx", 
        "SW43_i_SW00_rx", "SW43_i_SW00_tx", 
        "SW43_i_C37_rx", "SW43_i_C38_tx", 
        "SW43_i_C38_rx", "SW43_i_C38_tx", 
        "SW35_i_SW00_rx", "SW35_i_SW00_tx", "SW35_i_C39_rx", "SW35_i_C39_tx", 
        "SW00_i_SW40_rx", "SW00_i_SW40_tx", 
        "SW00_i_SW41_rx", "SW00_i_SW41_tx", 
        "SW00_i_SW42_rx", "SW00_i_SW42_tx", 
        "SW00_i_SW43_rx", "SW00_i_SW43_tx", 
        "SW00_i_SW35_rx", "SW00_i_SW35_tx", 
        "SW00_i_C16_rx", "SW00_i_C16_tx", 
        "SW40_i_C10_rx", "SW40_i_C11_rx", 
        "SW41_i_C12_rx", "SW41_i_C12_tx", 
        "SW41_i_SW00_rx", "SW41_i_SW00_tx", 
        "C13a_i_C13_hypervisor_rx", "C13_hypervisor_i_C13b_rx", "Switching_of_C13_hypervisor_1029.input-place");
      this.simQpnParser.interestingPlaces = _newLinkedList;
      LinkedList<String> _newLinkedList_1 = CollectionLiterals.<String>newLinkedList();
      this.simQpnParser.interestingColors = _newLinkedList_1;
      LinkedList<String> _newLinkedList_2 = CollectionLiterals.<String>newLinkedList("deptThrPut");
      this.simQpnParser.interestingMetrics = _newLinkedList_2;
      this.dniModels.clear();
      this.qpmeModels.clear();
      this.qpmeFiles.clear();
      this.qpmeSimulationResultFiles.clear();
      this.qpmeSimulationProcessedResults.clear();
      _xblockexpression = this.dni_base_model_file = "models/scenario0A.model";
    }
    return _xblockexpression;
  }
  
  public void start_experiment1(final boolean simulate) {
    String finalResult = "";
    HashMap<String, String> exp2cfg = CollectionLiterals.<String, String>newHashMap();
    String expcfg_folder = "/home/mk/Desktop/experimentConfigs/";
    exp2cfg.put("Experiment-4_1", "4.cfg");
    exp2cfg.put("Experiment-4_2", "4.cfg");
    exp2cfg.put("Experiment-4_3", "4.cfg");
    exp2cfg.put("Experiment-4_4", "4.cfg");
    exp2cfg.put("Experiment-0_A", "0.cfg");
    exp2cfg.put("Experiment-0_B_1", "0.cfg");
    exp2cfg.put("Experiment-0_B_2", "0.cfg");
    exp2cfg.put("Experiment-0_B_3", "0.cfg");
    exp2cfg.put("Experiment-0_B_4a", "0.cfg");
    exp2cfg.put("Experiment-0_B_4b", "0.cfg");
    exp2cfg.put("Experiment-1_A_1client", "1A.cfg");
    exp2cfg.put("Experiment-1_A_5clients", "1A.cfg");
    exp2cfg.put("Experiment-1_A_10clients", "1A.cfg");
    exp2cfg.put("Experiment-1_A_15clients", "1A.cfg");
    exp2cfg.put("Experiment-1_A_20clients", "1A.cfg");
    exp2cfg.put("Experiment-1_A_25clients", "1A.cfg");
    exp2cfg.put("Experiment-1_A_30clients", "1A.cfg");
    exp2cfg.put("Experiment-1_A_35clients", "1A.cfg");
    exp2cfg.put("Experiment-1_B_hw_1client", "1B.cfg");
    exp2cfg.put("Experiment-1_B_hw_5clients", "1B.cfg");
    exp2cfg.put("Experiment-1_B_hw_10clients", "1B.cfg");
    exp2cfg.put("Experiment-1_B_hw_15clients", "1B.cfg");
    exp2cfg.put("Experiment-1_B_hw_20clients", "1B.cfg");
    exp2cfg.put("Experiment-1_B_hw_25clients", "1B.cfg");
    exp2cfg.put("Experiment-1_B_hw_30clients", "1B.cfg");
    exp2cfg.put("Experiment-1_B_hw_35clients", "1B.cfg");
    exp2cfg.put("Experiment-1_B_sw_1client", "1B.cfg");
    exp2cfg.put("Experiment-1_B_sw_2clients", "1B.cfg");
    exp2cfg.put("Experiment-1_B_sw_3clients", "1B.cfg");
    exp2cfg.put("Experiment-1_B_sw_5clients", "1B.cfg");
    exp2cfg.put("Experiment-1_C_native", "1C.cfg");
    exp2cfg.put("Experiment-1_C_hw", "1C.cfg");
    exp2cfg.put("Experiment-1_C_sw", "1C.cfg");
    exp2cfg.put("Experiment-2_A", "2A.cfg");
    exp2cfg.put("Experiment-2_B", "2BC.cfg");
    exp2cfg.put("Experiment-2_C", "2BC.cfg");
    exp2cfg.put("Experiment-3_1client", "3.cfg");
    exp2cfg.put("Experiment-3_2clients", "3.cfg");
    exp2cfg.put("Experiment-3_3clients", "3.cfg");
    ExperimentModel _experimentModel = new ExperimentModel("Experiment-4_1", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/4/scenario_4_1.zzz.results.xml");
    ExperimentModel _experimentModel_1 = new ExperimentModel("Experiment-4_2", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/4/scenario_4_2.zzz.results.xml");
    ExperimentModel _experimentModel_2 = new ExperimentModel("Experiment-4_3", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/4/scenario_4_3.zzz.results.xml");
    ExperimentModel _experimentModel_3 = new ExperimentModel("Experiment-4_4", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/4/scenario_4_4.zzz.results.xml");
    LinkedList<ExperimentModel> models = CollectionLiterals.<ExperimentModel>newLinkedList(_experimentModel, _experimentModel_1, _experimentModel_2, _experimentModel_3);
    for (final ExperimentModel m : models) {
      {
        String experimentName = ((ExperimentModel) m).getExperimentName();
        String _get = exp2cfg.get(experimentName);
        String _plus = (expcfg_folder + _get);
        LinkedList<String> _parseCSVFileAsList = DNIRunner_mk_old.parseCSVFileAsList(_plus);
        this.simQpnParser.interestingPlaces = _parseCSVFileAsList;
        String _modelURI = ((ExperimentModel) m).getModelURI();
        String result = this.parseResult(_modelURI, experimentName);
        String line = ((experimentName + " #\n") + result);
        String _finalResult = finalResult;
        finalResult = (_finalResult + line);
        InputOutput.<String>println(line);
        this.qpmeSimulationProcessedResults.add(result);
        this.saveOutput(finalResult, (("/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/" + experimentName) + ".final"));
        finalResult = "";
      }
    }
    this.cleanup();
  }
  
  public static LinkedList<String> parseCSVFileAsList(final String path) {
    try {
      LinkedList<String> lst = CollectionLiterals.<String>newLinkedList();
      FileReader _fileReader = new FileReader(path);
      BufferedReader br = new BufferedReader(_fileReader);
      String line = "";
      while ((!Objects.equal((line = br.readLine()), null))) {
        boolean _startsWith = line.startsWith("#");
        boolean _not = (!_startsWith);
        if (_not) {
          lst.add(line);
        }
      }
      return lst;
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  public void start_experiment2() {
    LinkedList<String> _newLinkedList = CollectionLiterals.<String>newLinkedList("rx_of_Receiver");
    this.simQpnParser.interestingPlaces = _newLinkedList;
    LinkedList<String> _newLinkedList_1 = CollectionLiterals.<String>newLinkedList("Flow-iperf_to_iperf-destination");
    this.simQpnParser.interestingColors = _newLinkedList_1;
    LinkedList<String> _newLinkedList_2 = CollectionLiterals.<String>newLinkedList("arrivThrPut", "deptThrPut");
    this.simQpnParser.interestingMetrics = _newLinkedList_2;
    this.epsilonTransformationParameters.clear();
    String expNamePrefix = "Experiment2";
    LinkedList<Integer> mtus = CollectionLiterals.<Integer>newLinkedList(Integer.valueOf(1500), Integer.valueOf(1188), Integer.valueOf(888), Integer.valueOf(588), Integer.valueOf(288), Integer.valueOf(128));
    int i = 0;
    for (final Boolean goOverSdnSW : Collections.<Boolean>unmodifiableList(CollectionLiterals.<Boolean>newArrayList(Boolean.valueOf(true)))) {
      for (final Integer swlatency : Collections.<Integer>unmodifiableList(CollectionLiterals.<Integer>newArrayList(Integer.valueOf(10), Integer.valueOf(20), Integer.valueOf(30), Integer.valueOf(40), Integer.valueOf(50)))) {
        for (final Integer mtu : mtus) {
          {
            int _i = i;
            i = (_i + 1);
            Integer param_MTUsize = mtu;
            Integer param_SdnSwSwitchingLatency = swlatency;
            int param_SdnSwSwitchingperfPPS = (10 * 1000);
            boolean param_goOverSdnSW = (goOverSdnSW).booleanValue();
            double param_SdnHwSwitchingLatency = 3.3;
            double param_SdnHwSwitchingperfPPS = 7.57E7;
            double param_SdnHwSwitchingperfBPS = (((101.8 * 1000) * 1000) * 1000);
            String expName = ((((((((((((expNamePrefix + ".mtu.") + param_MTUsize) + ".SWlatency.") + param_SdnSwSwitchingLatency) + ".SWpps.") + Integer.valueOf(param_SdnSwSwitchingperfPPS)) + ".HWlatency.") + Double.valueOf(param_SdnHwSwitchingLatency)) + ".HWpps.") + Double.valueOf(param_SdnHwSwitchingperfPPS)) + ".goOverSwSDN.") + Boolean.valueOf(param_goOverSdnSW));
            List<Variable> list = CollectionLiterals.<Variable>newLinkedList();
            Variable _variable = new Variable("param_goOverSdnSW", Boolean.valueOf(param_goOverSdnSW), EolPrimitiveType.Boolean);
            list.add(_variable);
            Variable _variable_1 = new Variable("param_MTUsize", param_MTUsize, EolPrimitiveType.Integer);
            list.add(_variable_1);
            Variable _variable_2 = new Variable("param_SdnSwSwitchingLatency", param_SdnSwSwitchingLatency, EolPrimitiveType.Real);
            list.add(_variable_2);
            Variable _variable_3 = new Variable("param_SdnSwSwitchingperfPPS", Integer.valueOf(param_SdnSwSwitchingperfPPS), EolPrimitiveType.Integer);
            list.add(_variable_3);
            Variable _variable_4 = new Variable("param_SdnHwSwitchingLatency", Double.valueOf(param_SdnHwSwitchingLatency), EolPrimitiveType.Real);
            list.add(_variable_4);
            Variable _variable_5 = new Variable("param_SdnHwSwitchingperfPPS", Double.valueOf(param_SdnHwSwitchingperfPPS), EolPrimitiveType.Integer);
            list.add(_variable_5);
            Variable _variable_6 = new Variable("param_SdnHwSwitchingperfBPS", Double.valueOf(param_SdnHwSwitchingperfBPS), EolPrimitiveType.Real);
            list.add(_variable_6);
            this.epsilonTransformationParameters.put(expName, list);
            this.generateDniModel(this.dni_base_model_file, list, i, expName);
          }
        }
      }
    }
    this.checkDniModels();
    this.transformAll();
    this.generateQpeFiles();
    InputOutput.<String>println((("Starting run of " + Integer.valueOf(i)) + " simulations."));
    this.simulateAll();
    InputOutput.<String>println(("pwdURI " + this.pwdURI));
    InputOutput.<String>println(("pwdUnix " + this.pwdUnix));
    String _currentTimeStamp = DNIRunner.getCurrentTimeStamp();
    String _plus = (expNamePrefix + _currentTimeStamp);
    String _plus_1 = (_plus + "_final.txt");
    this.parseAllResults(_plus_1);
    final Procedure2<Object, Integer> _function = new Procedure2<Object, Integer>() {
      @Override
      public void apply(final Object pair, final Integer placeIndex) {
        ExperimentModel p = ((ExperimentModel) pair);
        String _experiment = p.getExperimentName();
        String _plus = ("EXP " + _experiment);
        String _plus_1 = (_plus + " FILE ");
        String _modelURI = p.getModelURI();
        String _plus_2 = (_plus_1 + _modelURI);
        InputOutput.<String>println(_plus_2);
      }
    };
    IterableExtensions.<Object>forEach(this.qpmeSimulationResultFiles, _function);
    this.cleanup();
  }
  
  public void start_experiment3_3500() {
    LinkedList<String> _newLinkedList = CollectionLiterals.<String>newLinkedList("rx_of_Receiver");
    this.simQpnParser.interestingPlaces = _newLinkedList;
    LinkedList<String> _newLinkedList_1 = CollectionLiterals.<String>newLinkedList("Flow-iperf_to_iperf-destination");
    this.simQpnParser.interestingColors = _newLinkedList_1;
    LinkedList<String> _newLinkedList_2 = CollectionLiterals.<String>newLinkedList("arrivThrPut");
    this.simQpnParser.interestingMetrics = _newLinkedList_2;
    this.epsilonTransformationParameters.clear();
    String expNamePrefix = "Experiment3_3500_";
    IntegerRange _upTo = new IntegerRange(1, 100);
    final Function1<Integer, Integer> _function = new Function1<Integer, Integer>() {
      @Override
      public Integer apply(final Integer v) {
        return Integer.valueOf(((v).intValue() * 100));
      }
    };
    Iterable<Integer> ppsList = IterableExtensions.<Integer, Integer>map(_upTo, _function);
    int i = 0;
    for (final Boolean goOverSdnSW : Collections.<Boolean>unmodifiableList(CollectionLiterals.<Boolean>newArrayList(Boolean.valueOf(true)))) {
      for (final Integer swlatency : Collections.<Integer>unmodifiableList(CollectionLiterals.<Integer>newArrayList(Integer.valueOf(0)))) {
        for (final Integer pps : ppsList) {
          {
            int _i = i;
            i = (_i + 1);
            int param_MTUsize = 1500;
            Integer param_SdnSwSwitchingLatency = swlatency;
            Integer param_SdnSwSwitchingperfPPS = pps;
            boolean param_goOverSdnSW = (goOverSdnSW).booleanValue();
            double param_SdnHwSwitchingLatency = 3.4;
            double param_SdnHwSwitchingperfPPS = 7.57E7;
            double param_SdnHwSwitchingperfBPS = 101.8;
            String expName = ((((((((((((expNamePrefix + ".mtu.") + Integer.valueOf(param_MTUsize)) + ".SWlatency.") + param_SdnSwSwitchingLatency) + ".SWpps.") + param_SdnSwSwitchingperfPPS) + ".HWlatency.") + Double.valueOf(param_SdnHwSwitchingLatency)) + ".HWpps.") + Double.valueOf(param_SdnHwSwitchingperfPPS)) + ".goOverSwSDN.") + Boolean.valueOf(param_goOverSdnSW));
            List<Variable> list = CollectionLiterals.<Variable>newLinkedList();
            Variable _variable = new Variable("param_goOverSdnSW", Boolean.valueOf(param_goOverSdnSW), EolPrimitiveType.Boolean);
            list.add(_variable);
            Variable _variable_1 = new Variable("param_MTUsize", Integer.valueOf(param_MTUsize), EolPrimitiveType.Integer);
            list.add(_variable_1);
            Variable _variable_2 = new Variable("param_SdnSwSwitchingLatency", param_SdnSwSwitchingLatency, EolPrimitiveType.Real);
            list.add(_variable_2);
            Variable _variable_3 = new Variable("param_SdnSwSwitchingperfPPS", param_SdnSwSwitchingperfPPS, EolPrimitiveType.Integer);
            list.add(_variable_3);
            Variable _variable_4 = new Variable("param_SdnHwSwitchingLatency", Double.valueOf(param_SdnHwSwitchingLatency), EolPrimitiveType.Real);
            list.add(_variable_4);
            Variable _variable_5 = new Variable("param_SdnHwSwitchingperfPPS", Double.valueOf(param_SdnHwSwitchingperfPPS), EolPrimitiveType.Integer);
            list.add(_variable_5);
            Variable _variable_6 = new Variable("param_SdnHwSwitchingperfBPS", Double.valueOf(param_SdnHwSwitchingperfBPS), EolPrimitiveType.Real);
            list.add(_variable_6);
            this.epsilonTransformationParameters.put(expName, list);
            this.generateDniModel(this.dni_base_model_file, list, i, expName);
          }
        }
      }
    }
    this.checkDniModels();
    this.transformAll();
    this.generateQpeFiles();
    InputOutput.<String>println((("Starting run of " + Integer.valueOf(i)) + " simulations."));
    this.simulateAll();
    InputOutput.<String>println(("pwdURI " + this.pwdURI));
    InputOutput.<String>println(("pwdUnix " + this.pwdUnix));
    String _currentTimeStamp = DNIRunner.getCurrentTimeStamp();
    String _plus = (expNamePrefix + _currentTimeStamp);
    String _plus_1 = (_plus + "_final.txt");
    this.parseAllResults(_plus_1);
    final Procedure2<Object, Integer> _function_1 = new Procedure2<Object, Integer>() {
      @Override
      public void apply(final Object pair, final Integer placeIndex) {
        ExperimentModel p = ((ExperimentModel) pair);
        String _experiment = p.getExperimentName();
        String _plus = ("EXP " + _experiment);
        String _plus_1 = (_plus + " FILE ");
        String _modelURI = p.getModelURI();
        String _plus_2 = (_plus_1 + _modelURI);
        InputOutput.<String>println(_plus_2);
      }
    };
    IterableExtensions.<Object>forEach(this.qpmeSimulationResultFiles, _function_1);
    this.cleanup();
  }
  
  public void start_experiment3_2920() {
    LinkedList<String> _newLinkedList = CollectionLiterals.<String>newLinkedList("rx_of_Receiver");
    this.simQpnParser.interestingPlaces = _newLinkedList;
    LinkedList<String> _newLinkedList_1 = CollectionLiterals.<String>newLinkedList("Flow-iperf_to_iperf-destination");
    this.simQpnParser.interestingColors = _newLinkedList_1;
    LinkedList<String> _newLinkedList_2 = CollectionLiterals.<String>newLinkedList("arrivThrPut");
    this.simQpnParser.interestingMetrics = _newLinkedList_2;
    this.epsilonTransformationParameters.clear();
    String expNamePrefix = "Experiment3_2920_";
    IntegerRange _upTo = new IntegerRange(1, 20);
    final Function1<Integer, Integer> _function = new Function1<Integer, Integer>() {
      @Override
      public Integer apply(final Integer v) {
        return Integer.valueOf(((v).intValue() * 100));
      }
    };
    Iterable<Integer> ppsList = IterableExtensions.<Integer, Integer>map(_upTo, _function);
    int i = 0;
    for (final Boolean goOverSdnSW : Collections.<Boolean>unmodifiableList(CollectionLiterals.<Boolean>newArrayList(Boolean.valueOf(true)))) {
      for (final Integer swlatency : Collections.<Integer>unmodifiableList(CollectionLiterals.<Integer>newArrayList(Integer.valueOf(200), Integer.valueOf(300)))) {
        for (final Integer pps : ppsList) {
          {
            int _i = i;
            i = (_i + 1);
            int param_MTUsize = 1500;
            Integer param_SdnSwSwitchingLatency = swlatency;
            Integer param_SdnSwSwitchingperfPPS = pps;
            boolean param_goOverSdnSW = (goOverSdnSW).booleanValue();
            double param_SdnHwSwitchingLatency = 3.3;
            double param_SdnHwSwitchingperfPPS = (92.2 * 1000000);
            int param_SdnHwSwitchingperfBPS = 128;
            String expName = ((((((((((((expNamePrefix + ".mtu.") + Integer.valueOf(param_MTUsize)) + ".SWlatency.") + param_SdnSwSwitchingLatency) + ".SWpps.") + param_SdnSwSwitchingperfPPS) + ".HWlatency.") + Double.valueOf(param_SdnHwSwitchingLatency)) + ".HWpps.") + Double.valueOf(param_SdnHwSwitchingperfPPS)) + ".goOverSwSDN.") + Boolean.valueOf(param_goOverSdnSW));
            List<Variable> list = CollectionLiterals.<Variable>newLinkedList();
            Variable _variable = new Variable("param_goOverSdnSW", Boolean.valueOf(param_goOverSdnSW), EolPrimitiveType.Boolean);
            list.add(_variable);
            Variable _variable_1 = new Variable("param_MTUsize", Integer.valueOf(param_MTUsize), EolPrimitiveType.Integer);
            list.add(_variable_1);
            Variable _variable_2 = new Variable("param_SdnSwSwitchingLatency", param_SdnSwSwitchingLatency, EolPrimitiveType.Real);
            list.add(_variable_2);
            Variable _variable_3 = new Variable("param_SdnSwSwitchingperfPPS", param_SdnSwSwitchingperfPPS, EolPrimitiveType.Integer);
            list.add(_variable_3);
            Variable _variable_4 = new Variable("param_SdnHwSwitchingLatency", Double.valueOf(param_SdnHwSwitchingLatency), EolPrimitiveType.Real);
            list.add(_variable_4);
            Variable _variable_5 = new Variable("param_SdnHwSwitchingperfPPS", Double.valueOf(param_SdnHwSwitchingperfPPS), EolPrimitiveType.Integer);
            list.add(_variable_5);
            Variable _variable_6 = new Variable("param_SdnHwSwitchingperfBPS", Integer.valueOf(param_SdnHwSwitchingperfBPS), EolPrimitiveType.Real);
            list.add(_variable_6);
            this.epsilonTransformationParameters.put(expName, list);
            this.generateDniModel(this.dni_base_model_file, list, i, expName);
          }
        }
      }
    }
    this.checkDniModels();
    this.transformAll();
    this.generateQpeFiles();
    InputOutput.<String>println((("Starting run of " + Integer.valueOf(i)) + " simulations."));
    this.simulateAll();
    InputOutput.<String>println(("pwdURI " + this.pwdURI));
    InputOutput.<String>println(("pwdUnix " + this.pwdUnix));
    String _currentTimeStamp = DNIRunner.getCurrentTimeStamp();
    String _plus = (expNamePrefix + _currentTimeStamp);
    String _plus_1 = (_plus + "_final.txt");
    this.parseAllResults(_plus_1);
    final Procedure2<Object, Integer> _function_1 = new Procedure2<Object, Integer>() {
      @Override
      public void apply(final Object pair, final Integer placeIndex) {
        ExperimentModel p = ((ExperimentModel) pair);
        String _experiment = p.getExperimentName();
        String _plus = ("EXP " + _experiment);
        String _plus_1 = (_plus + " FILE ");
        String _modelURI = p.getModelURI();
        String _plus_2 = (_plus_1 + _modelURI);
        InputOutput.<String>println(_plus_2);
      }
    };
    IterableExtensions.<Object>forEach(this.qpmeSimulationResultFiles, _function_1);
    this.cleanup();
  }
}
