package epsilonStandalone

import epsilonStandalone.DNIRunner
import org.eclipse.epsilon.eol.execute.context.Variable
import org.eclipse.epsilon.eol.types.EolPrimitiveType
import java.util.List

class DNIRunner_old_2 extends DNIRunner {
	
	public def static void main(String[] args) {
	  	
	  	val a = new DNIRunner_old_2()
	  	a.reset()
	  	a.start_experiment1(true)
		  	
  	}
  	
  	public def reset(){
  		simQpnParser.interestingPlaces = newLinkedList("SW40_i_SW00_rx", "SW40_i_SW00_tx",
  			
  													   "SW41_i_SW00_rx", "SW41_i_SW00_tx",
  													   "SW41_i_C12_rx", "SW41_i_C12_tx",
  													   "SW41_i_C13_rx", "SW41_i_C13_tx",
  													   
  													   "SW42_i_SW00_rx", "SW42_i_SW00_tx",
  													   "SW42_i_C17_rx", "SW42_i_C17_tx",
  													   "SW42_i_C36_rx", "SW42_i_C36_tx",
  													   
  													   "SW43_i_SW00_rx", "SW43_i_SW00_tx",
  													   "SW43_i_C37_rx", "SW43_i_C38_tx",
  													   "SW43_i_C38_rx", "SW43_i_C38_tx",
  													   
  													   
  													   "SW35_i1_rx", "SW35_i1_tx", "SW35_i2_rx", "SW35_i2_tx",
  													   
  													   "SW00_i_SW40_rx", "SW00_i_SW40_tx",
  													   "SW00_i_SW41_rx", "SW00_i_SW41_tx",
  													   "SW00_i_SW42_rx", "SW00_i_SW42_tx",
  													   "SW00_i_SW43_rx", "SW00_i_SW43_tx",
  													   "SW00_i_SW35_rx", "SW00_i_SW35_tx",
  													   "SW00_i_C16_rx", "SW00_i_C16_tx",
  													   
  													  	
  													   
  													   "SW40_i_C10_rx", "SW40_i_C11_rx",
  													   "SW41_i_C12_rx", "SW41_i_C13_rx",
  													   "SW42_i_C17_rx", "SW42_i_C36_rx",
  													   "SW42_i_C17_tx", "SW42_i_C36_tx",
  													   "SW43_i_C37_rx", "SW43_i_C38_rx",
  													   
  													   "SW35_i2_tx", "SW35_i2_rx",
  													   
  													   "C13_i1_rx", "C13_i1_tx",
  													   "C13a_i_C13_rx", "C13a_i_C13_tx",
  													   "C13a_i_C13b_rx", "C13a_i_C13b_tx",
  													   "C13b_i_C13_rx", "C13b_i_C13_tx",
  													   "C13b_i_C13a_rx", "C13b_i_C13a_tx"
  													     //"SDN_Switching_of_SW41"
  													   )//, "SW_SDN_Switching_QP_SwitchSDN(HP3500)", "HW_SDN_Switching_QP_SwitchSDN(HP3500)")
  		
  		simQpnParser.interestingColors = newLinkedList(/*"Traffic_send_C10-to-C39",
  													   "Traffic_send_C12-to-C38",
  													   "Traffic_send_C36-to-C17",
  													   "Traffic_send_C39-to-C10",
  													   "Traffic_send_C38-to-C11",
  													   "Traffic_send_C37-to-C12",
  													   "Traffic_send_C38-to-C12",
  													   "Traffic_send_C10-to-C17"*/
  													   "Traffic_send")
  		simQpnParser.interestingMetrics = newLinkedList("arrivThrPut")//, "deptThrPut")
  		
  		dniModels.clear
		qpmeModels.clear
		qpmeFiles.clear
		qpmeSimulationResultFiles.clear
		qpmeSimulationProcessedResults.clear
  		
  		dni_base_model_file = "models/scenario0A.model"
  		
  		
  	}
	
	
	public def start_experiment1(boolean simulate){
		
		var String finalResult = ""
		
		var models = newLinkedList(/*new ExperimentModel("Experiment-0A", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/0/scenario0A.zzz.results.xml"),
								   new ExperimentModel("Experiment-0B1", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/0/scenario0B1.zzz.results.xml"),
								   new ExperimentModel("Experiment-0B2", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/0/scenario0B2.zzz.results.xml"),
								   new ExperimentModel("Experiment-0B3", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/0/scenario0B3.zzz.results.xml"),
								   new ExperimentModel("Experiment-0B4A", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/0/scenario0B4A.zzz.results.xml"),
								   new ExperimentModel("Experiment-0B4B", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/0/scenario0B4B.zzz.results.xml"),*/
								   
								   /*new ExperimentModel("Experiment-1A-10clients", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/1A/Experiment-1A.clients.10.zzz.results.xml"),
								   new ExperimentModel("Experiment-1A-15clients", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/1A/Experiment-1A.clients.15.zzz.results.xml"),
								   new ExperimentModel("Experiment-1A-20clients", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/1A/Experiment-1A.clients.20.zzz.results.xml"),
								   new ExperimentModel("Experiment-1A-25clients", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/1A/Experiment-1A.clients.25.zzz.results.xml")*/
								   
								   new ExperimentModel("Experiment-2", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/2/scenario2.zzz.results.xml")
								   
								   /* 
								   new ExperimentModel("Experiment-1C-native", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/1C/scenario1C_native.results.xml"),
								   new ExperimentModel("Experiment-1C-hw", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/1C/scenario1C_hw.results.xml"),
								   new ExperimentModel("Experiment-1C-sw", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/1C/scenario1C_sw.results.xml")*/
								   //new ExperimentModel("Experiment-1A-5clients", "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/1A/Experiment-1A.clients.5.zzz.results.xml"
		)						
		
		for (m : models) {
			var experimentName = (m as ExperimentModel).experiment
			var String result = parseResult((m as ExperimentModel).modelURI, experimentName)
			var String line = experimentName+" # "+result
			finalResult += line
			println(line)
			qpmeSimulationProcessedResults.add(result) 
					
			saveOutput(finalResult, "/home/mk/workspaces/workspace_DNI_neo/DNI3/output/results/"+experimentName+".final")
			
			finalResult = ""
		}	

		cleanup
	}
	
	public def start_experiment2(){
		
		simQpnParser.interestingPlaces = newLinkedList("rx_of_Receiver")//, "SW_SDN_Switching_QP_SwitchSDN(HP3500)", "HW_SDN_Switching_QP_SwitchSDN(HP3500)")
  		simQpnParser.interestingColors = newLinkedList("Flow-iperf_to_iperf-destination")
  		simQpnParser.interestingMetrics = newLinkedList("arrivThrPut")//, "deptThrPut")

		epsilonTransformationParameters.clear
		var expNamePrefix = "Experiment2";
		var mtus = newLinkedList(1500, 1188, 888, 588, 288, 128)
		
		var int i = 0
		for(goOverSdnSW : #[true]){
			for(swlatency : #[10,20,30,40,50]){ //currently in us
				for(Integer mtu : mtus){
					i+=1
					var param_MTUsize = mtu //1500; //B
					var param_SdnSwSwitchingLatency = swlatency//3.3 //us
					var param_SdnSwSwitchingperfPPS = 10*1000 //100000;  //PPS
					
					var boolean param_goOverSdnSW = goOverSdnSW
					var param_SdnHwSwitchingLatency = 3.3 //us
					var param_SdnHwSwitchingperfPPS = 7.57E7 //100000;  //PPS
					var param_SdnHwSwitchingperfBPS = 101.8*1000*1000*1000
					
					var String expName = expNamePrefix+".mtu."+param_MTUsize+".SWlatency."+param_SdnSwSwitchingLatency+".SWpps."+param_SdnSwSwitchingperfPPS+".HWlatency."+param_SdnHwSwitchingLatency+".HWpps."+param_SdnHwSwitchingperfPPS+".goOverSwSDN."+param_goOverSdnSW;
					
					
					var List<Variable> list = newLinkedList()
					list.add(new Variable("param_goOverSdnSW", param_goOverSdnSW, EolPrimitiveType.Boolean))
					list.add(new Variable("param_MTUsize", param_MTUsize, EolPrimitiveType.Integer))
					list.add(new Variable("param_SdnSwSwitchingLatency", param_SdnSwSwitchingLatency, EolPrimitiveType.Real))
					list.add(new Variable("param_SdnSwSwitchingperfPPS", param_SdnSwSwitchingperfPPS, EolPrimitiveType.Integer))
					
					list.add(new Variable("param_SdnHwSwitchingLatency", param_SdnHwSwitchingLatency, EolPrimitiveType.Real))
					list.add(new Variable("param_SdnHwSwitchingperfPPS", param_SdnHwSwitchingperfPPS, EolPrimitiveType.Integer))
					list.add(new Variable("param_SdnHwSwitchingperfBPS", param_SdnHwSwitchingperfBPS, EolPrimitiveType.Real))
					epsilonTransformationParameters.put(expName, list)
					
					
					
					generateDniModel(dni_base_model_file, list, i, expName)
				}
			}
		}
		
		//from here, the expName is accessible only via linked lists!!
		
		
		//dniModels is filled
		checkDniModels		// eol //optional
		transformAll		// etl
		//qpmeModels is filled
		generateQpeFiles	//egl
		//qpmeFiles is filled 
		println("Starting run of "+i+" simulations.")
		simulateAll			//bash SimQPN simulation
		//qpmeSimulationResultFiles is filled
		
		println("pwdURI "+pwdURI)
		println("pwdUnix "+pwdUnix)
		
		
				
				
		parseAllResults(expNamePrefix+getCurrentTimeStamp+"_final.txt")
		//qpmeSimulationProcessedResults is filled
		
		qpmeSimulationResultFiles.forEach[pair, placeIndex|
			var p = pair as ExperimentModel
			println("EXP "+p.experiment+" FILE "+p.modelURI)
		]
		
		
		///cleanup
		cleanup
	}
	
	public def start_experiment3_3500(){
		
		simQpnParser.interestingPlaces = newLinkedList("rx_of_Receiver")//, "SW_SDN_Switching_QP_SwitchSDN(HP3500)", "HW_SDN_Switching_QP_SwitchSDN(HP3500)")
  		simQpnParser.interestingColors = newLinkedList("Flow-iperf_to_iperf-destination")
  		simQpnParser.interestingMetrics = newLinkedList("arrivThrPut")//, "deptThrPut")

		epsilonTransformationParameters.clear
		var expNamePrefix = "Experiment3_3500_";
		
		var ppsList = (1..100).map[v|v*100]
		
		var int i = 0
		for(goOverSdnSW : #[true]){
			for(swlatency : #[0]){ //currently in us
				for(Integer pps : ppsList){
					i+=1
					var param_MTUsize = 1500
					var param_SdnSwSwitchingLatency = swlatency
					var param_SdnSwSwitchingperfPPS = pps 
					
					var boolean param_goOverSdnSW = goOverSdnSW
					var param_SdnHwSwitchingLatency = 3.4
					var param_SdnHwSwitchingperfPPS = 7.57E7
					var param_SdnHwSwitchingperfBPS = 101.8// prefix G is default *1000*1000*1000
					
					var String expName = expNamePrefix+".mtu."+param_MTUsize+".SWlatency."+param_SdnSwSwitchingLatency+".SWpps."+param_SdnSwSwitchingperfPPS+".HWlatency."+param_SdnHwSwitchingLatency+".HWpps."+param_SdnHwSwitchingperfPPS+".goOverSwSDN."+param_goOverSdnSW;
					
					
					var List<Variable> list = newLinkedList()
					list.add(new Variable("param_goOverSdnSW", param_goOverSdnSW, EolPrimitiveType.Boolean))
					list.add(new Variable("param_MTUsize", param_MTUsize, EolPrimitiveType.Integer))
					list.add(new Variable("param_SdnSwSwitchingLatency", param_SdnSwSwitchingLatency, EolPrimitiveType.Real))
					list.add(new Variable("param_SdnSwSwitchingperfPPS", param_SdnSwSwitchingperfPPS, EolPrimitiveType.Integer))
					
					list.add(new Variable("param_SdnHwSwitchingLatency", param_SdnHwSwitchingLatency, EolPrimitiveType.Real))
					list.add(new Variable("param_SdnHwSwitchingperfPPS", param_SdnHwSwitchingperfPPS, EolPrimitiveType.Integer))
					list.add(new Variable("param_SdnHwSwitchingperfBPS", param_SdnHwSwitchingperfBPS, EolPrimitiveType.Real))
					epsilonTransformationParameters.put(expName, list)
					
					
					
					generateDniModel(dni_base_model_file, list, i, expName)
				}
			}
		}
		
		//from here, the expName is accessible only via linked lists!!
		
		
		//dniModels is filled
		checkDniModels		// eol //optional
		transformAll		// etl
		//qpmeModels is filled
		generateQpeFiles	//egl
		//qpmeFiles is filled 
		println("Starting run of "+i+" simulations.")
		simulateAll			//bash SimQPN simulation
		//qpmeSimulationResultFiles is filled
		
		println("pwdURI "+pwdURI)
		println("pwdUnix "+pwdUnix)
		
		
				
				
		parseAllResults(expNamePrefix+getCurrentTimeStamp+"_final.txt")
		//qpmeSimulationProcessedResults is filled
		
		qpmeSimulationResultFiles.forEach[pair, placeIndex|
			var p = pair as ExperimentModel
			println("EXP "+p.experiment+" FILE "+p.modelURI)
		]

		///cleanup
		cleanup
	}
	
	public def start_experiment3_2920(){
		
		simQpnParser.interestingPlaces = newLinkedList("rx_of_Receiver")//, "SW_SDN_Switching_QP_SwitchSDN(HP3500)", "HW_SDN_Switching_QP_SwitchSDN(HP3500)")
  		simQpnParser.interestingColors = newLinkedList("Flow-iperf_to_iperf-destination")
  		simQpnParser.interestingMetrics = newLinkedList("arrivThrPut")//, "deptThrPut")

		epsilonTransformationParameters.clear
		var expNamePrefix = "Experiment3_2920_";
		
		var ppsList = (1..20).map[v|v*100]
		
		var int i = 0
		for(goOverSdnSW : #[true]){
			for(swlatency : #[200, 300]){ //currently in us
				for(Integer pps : ppsList){
					i+=1
					var param_MTUsize = 1500
					var param_SdnSwSwitchingLatency = swlatency
					var param_SdnSwSwitchingperfPPS = pps 
					
					var boolean param_goOverSdnSW = goOverSdnSW
					var param_SdnHwSwitchingLatency = 3.3 
					var param_SdnHwSwitchingperfPPS = 92.2*1000000
					var param_SdnHwSwitchingperfBPS = 128// prefix G is default *1000*1000*1000
					
					var String expName = expNamePrefix+".mtu."+param_MTUsize+".SWlatency."+param_SdnSwSwitchingLatency+".SWpps."+param_SdnSwSwitchingperfPPS+".HWlatency."+param_SdnHwSwitchingLatency+".HWpps."+param_SdnHwSwitchingperfPPS+".goOverSwSDN."+param_goOverSdnSW;
					
					
					var List<Variable> list = newLinkedList()
					list.add(new Variable("param_goOverSdnSW", param_goOverSdnSW, EolPrimitiveType.Boolean))
					list.add(new Variable("param_MTUsize", param_MTUsize, EolPrimitiveType.Integer))
					list.add(new Variable("param_SdnSwSwitchingLatency", param_SdnSwSwitchingLatency, EolPrimitiveType.Real))
					list.add(new Variable("param_SdnSwSwitchingperfPPS", param_SdnSwSwitchingperfPPS, EolPrimitiveType.Integer))
					
					list.add(new Variable("param_SdnHwSwitchingLatency", param_SdnHwSwitchingLatency, EolPrimitiveType.Real))
					list.add(new Variable("param_SdnHwSwitchingperfPPS", param_SdnHwSwitchingperfPPS, EolPrimitiveType.Integer))
					list.add(new Variable("param_SdnHwSwitchingperfBPS", param_SdnHwSwitchingperfBPS, EolPrimitiveType.Real))
					epsilonTransformationParameters.put(expName, list)
					
					
					
					generateDniModel(dni_base_model_file, list, i, expName)
				}
			}
		}
		
		//from here, the expName is accessible only via linked lists!!
		
		
		//dniModels is filled
		checkDniModels		// eol //optional
		transformAll		// etl
		//qpmeModels is filled
		generateQpeFiles	//egl
		//qpmeFiles is filled 
		println("Starting run of "+i+" simulations.")
		simulateAll			//bash SimQPN simulation
		//qpmeSimulationResultFiles is filled
		
		println("pwdURI "+pwdURI)
		println("pwdUnix "+pwdUnix)
		
		
				
				
		parseAllResults(expNamePrefix+getCurrentTimeStamp+"_final.txt")
		//qpmeSimulationProcessedResults is filled
		
		qpmeSimulationResultFiles.forEach[pair, placeIndex|
			var p = pair as ExperimentModel
			println("EXP "+p.experiment+" FILE "+p.modelURI)
		]
		
		
		///cleanup
		cleanup
	}
}