/**
 */
package tools.descartes.dni.dnimm3.impl;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import tools.descartes.dni.dnimm3.DNIPackage;
import tools.descartes.dni.dnimm3.Entity;
import tools.descartes.dni.dnimm3.EntityAddress;
import tools.descartes.dni.dnimm3.Identifier;
import tools.descartes.dni.dnimm3.NamedElement;
import tools.descartes.dni.dnimm3.NetworkInterface;
import tools.descartes.dni.dnimm3.NetworkInterfaceType;
import tools.descartes.dni.dnimm3.Node;
import tools.descartes.dni.dnimm3.PerformanceNetworkInterface;
import tools.descartes.dni.dnimm3.ProtocolStack;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Network Interface</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dni.dnimm3.impl.NetworkInterfaceImpl#getAddresses <em>Addresses</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3.impl.NetworkInterfaceImpl#getName <em>Name</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3.impl.NetworkInterfaceImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3.impl.NetworkInterfaceImpl#getUid <em>Uid</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3.impl.NetworkInterfaceImpl#getUid_generated <em>Uid generated</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3.impl.NetworkInterfaceImpl#getUsedProtocolStack <em>Used Protocol Stack</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3.impl.NetworkInterfaceImpl#getPerformance <em>Performance</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3.impl.NetworkInterfaceImpl#getNode <em>Node</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3.impl.NetworkInterfaceImpl#getName_generated <em>Name generated</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3.impl.NetworkInterfaceImpl#getEntityType <em>Entity Type</em>}</li>
 * </ul>
 *
 * @generated
 */
public class NetworkInterfaceImpl extends MinimalEObjectImpl.Container implements NetworkInterface {
	/**
	 * The cached value of the '{@link #getAddresses() <em>Addresses</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAddresses()
	 * @generated
	 * @ordered
	 */
	protected EList<EntityAddress> addresses;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected String description = DESCRIPTION_EDEFAULT;

	/**
	 * The default value of the '{@link #getUid() <em>Uid</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUid()
	 * @generated
	 * @ordered
	 */
	protected static final String UID_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getUid() <em>Uid</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUid()
	 * @generated
	 * @ordered
	 */
	protected String uid = UID_EDEFAULT;

	/**
	 * This is true if the Uid attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean uidESet;

	/**
	 * The default value of the '{@link #getUid_generated() <em>Uid generated</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUid_generated()
	 * @generated
	 * @ordered
	 */
	protected static final String UID_GENERATED_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getUsedProtocolStack() <em>Used Protocol Stack</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUsedProtocolStack()
	 * @generated
	 * @ordered
	 */
	protected ProtocolStack usedProtocolStack;

	/**
	 * The cached value of the '{@link #getPerformance() <em>Performance</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPerformance()
	 * @generated
	 * @ordered
	 */
	protected PerformanceNetworkInterface performance;

	/**
	 * The default value of the '{@link #getName_generated() <em>Name generated</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName_generated()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_GENERATED_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getEntityType() <em>Entity Type</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEntityType()
	 * @generated
	 * @ordered
	 */
	protected NetworkInterfaceType entityType;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected NetworkInterfaceImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return DNIPackage.Literals.NETWORK_INTERFACE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List<EntityAddress> getAddresses() {
		if (addresses == null) {
			addresses = new EObjectContainmentEList<EntityAddress>(EntityAddress.class, this, DNIPackage.NETWORK_INTERFACE__ADDRESSES);
		}
		return addresses;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIPackage.NETWORK_INTERFACE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDescription(String newDescription) {
		String oldDescription = description;
		description = newDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIPackage.NETWORK_INTERFACE__DESCRIPTION, oldDescription, description));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getUid() {
		return uid;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUid(String newUid) {
		String oldUid = uid;
		uid = newUid;
		boolean oldUidESet = uidESet;
		uidESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIPackage.NETWORK_INTERFACE__UID, oldUid, uid, !oldUidESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetUid() {
		String oldUid = uid;
		boolean oldUidESet = uidESet;
		uid = UID_EDEFAULT;
		uidESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, DNIPackage.NETWORK_INTERFACE__UID, oldUid, UID_EDEFAULT, oldUidESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetUid() {
		return uidESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getUid_generated() {
		if (((this.getUid() == null) || this.getUid().isEmpty())) {
			this.setUid(EcoreUtil.generateUUID().toString());
		}
		return this.getUid();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProtocolStack getUsedProtocolStack() {
		if (usedProtocolStack != null && usedProtocolStack.eIsProxy()) {
			InternalEObject oldUsedProtocolStack = (InternalEObject)usedProtocolStack;
			usedProtocolStack = (ProtocolStack)eResolveProxy(oldUsedProtocolStack);
			if (usedProtocolStack != oldUsedProtocolStack) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, DNIPackage.NETWORK_INTERFACE__USED_PROTOCOL_STACK, oldUsedProtocolStack, usedProtocolStack));
			}
		}
		return usedProtocolStack;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProtocolStack basicGetUsedProtocolStack() {
		return usedProtocolStack;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUsedProtocolStack(ProtocolStack newUsedProtocolStack) {
		ProtocolStack oldUsedProtocolStack = usedProtocolStack;
		usedProtocolStack = newUsedProtocolStack;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIPackage.NETWORK_INTERFACE__USED_PROTOCOL_STACK, oldUsedProtocolStack, usedProtocolStack));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PerformanceNetworkInterface getPerformance() {
		return performance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPerformance(PerformanceNetworkInterface newPerformance, NotificationChain msgs) {
		PerformanceNetworkInterface oldPerformance = performance;
		performance = newPerformance;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DNIPackage.NETWORK_INTERFACE__PERFORMANCE, oldPerformance, newPerformance);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPerformance(PerformanceNetworkInterface newPerformance) {
		if (newPerformance != performance) {
			NotificationChain msgs = null;
			if (performance != null)
				msgs = ((InternalEObject)performance).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DNIPackage.NETWORK_INTERFACE__PERFORMANCE, null, msgs);
			if (newPerformance != null)
				msgs = ((InternalEObject)newPerformance).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DNIPackage.NETWORK_INTERFACE__PERFORMANCE, null, msgs);
			msgs = basicSetPerformance(newPerformance, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIPackage.NETWORK_INTERFACE__PERFORMANCE, newPerformance, newPerformance));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Node getNode() {
		if (eContainerFeatureID() != DNIPackage.NETWORK_INTERFACE__NODE) return null;
		return (Node)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Node basicGetNode() {
		if (eContainerFeatureID() != DNIPackage.NETWORK_INTERFACE__NODE) return null;
		return (Node)eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetNode(Node newNode, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newNode, DNIPackage.NETWORK_INTERFACE__NODE, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setNode(Node newNode) {
		if (newNode != eInternalContainer() || (eContainerFeatureID() != DNIPackage.NETWORK_INTERFACE__NODE && newNode != null)) {
			if (EcoreUtil.isAncestor(this, newNode))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newNode != null)
				msgs = ((InternalEObject)newNode).eInverseAdd(this, DNIPackage.NODE__INTERFACES, Node.class, msgs);
			msgs = basicSetNode(newNode, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIPackage.NETWORK_INTERFACE__NODE, newNode, newNode));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName_generated() {
		if (((this.getDescription() == null) || this.getDescription().isEmpty())) {
			String _name = this.getNode().getName();
			String _plus = (("Unnamed_iface_" + "[") + _name);
			String _plus_1 = (_plus + "]");
			this.setName(_plus_1);
		}
		String _description = this.getDescription();
		String _plus_2 = (_description + "[");
		String _name_1 = this.getNode().getName();
		String _plus_3 = (_plus_2 + _name_1);
		String _plus_4 = (_plus_3 + "]");
		this.setName(_plus_4);
		return this.getName();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NetworkInterfaceType getEntityType() {
		if (entityType != null && entityType.eIsProxy()) {
			InternalEObject oldEntityType = (InternalEObject)entityType;
			entityType = (NetworkInterfaceType)eResolveProxy(oldEntityType);
			if (entityType != oldEntityType) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, DNIPackage.NETWORK_INTERFACE__ENTITY_TYPE, oldEntityType, entityType));
			}
		}
		return entityType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NetworkInterfaceType basicGetEntityType() {
		return entityType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetEntityType(NetworkInterfaceType newEntityType, NotificationChain msgs) {
		NetworkInterfaceType oldEntityType = entityType;
		entityType = newEntityType;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DNIPackage.NETWORK_INTERFACE__ENTITY_TYPE, oldEntityType, newEntityType);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEntityType(NetworkInterfaceType newEntityType) {
		if (newEntityType != entityType) {
			NotificationChain msgs = null;
			if (entityType != null)
				msgs = ((InternalEObject)entityType).eInverseRemove(this, DNIPackage.NETWORK_INTERFACE_TYPE__ENTITIES, NetworkInterfaceType.class, msgs);
			if (newEntityType != null)
				msgs = ((InternalEObject)newEntityType).eInverseAdd(this, DNIPackage.NETWORK_INTERFACE_TYPE__ENTITIES, NetworkInterfaceType.class, msgs);
			msgs = basicSetEntityType(newEntityType, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIPackage.NETWORK_INTERFACE__ENTITY_TYPE, newEntityType, newEntityType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case DNIPackage.NETWORK_INTERFACE__NODE:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetNode((Node)otherEnd, msgs);
			case DNIPackage.NETWORK_INTERFACE__ENTITY_TYPE:
				if (entityType != null)
					msgs = ((InternalEObject)entityType).eInverseRemove(this, DNIPackage.NETWORK_INTERFACE_TYPE__ENTITIES, NetworkInterfaceType.class, msgs);
				return basicSetEntityType((NetworkInterfaceType)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case DNIPackage.NETWORK_INTERFACE__ADDRESSES:
				return ((InternalEList<?>)getAddresses()).basicRemove(otherEnd, msgs);
			case DNIPackage.NETWORK_INTERFACE__PERFORMANCE:
				return basicSetPerformance(null, msgs);
			case DNIPackage.NETWORK_INTERFACE__NODE:
				return basicSetNode(null, msgs);
			case DNIPackage.NETWORK_INTERFACE__ENTITY_TYPE:
				return basicSetEntityType(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case DNIPackage.NETWORK_INTERFACE__NODE:
				return eInternalContainer().eInverseRemove(this, DNIPackage.NODE__INTERFACES, Node.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case DNIPackage.NETWORK_INTERFACE__ADDRESSES:
				return getAddresses();
			case DNIPackage.NETWORK_INTERFACE__NAME:
				return getName();
			case DNIPackage.NETWORK_INTERFACE__DESCRIPTION:
				return getDescription();
			case DNIPackage.NETWORK_INTERFACE__UID:
				return getUid();
			case DNIPackage.NETWORK_INTERFACE__UID_GENERATED:
				return getUid_generated();
			case DNIPackage.NETWORK_INTERFACE__USED_PROTOCOL_STACK:
				if (resolve) return getUsedProtocolStack();
				return basicGetUsedProtocolStack();
			case DNIPackage.NETWORK_INTERFACE__PERFORMANCE:
				return getPerformance();
			case DNIPackage.NETWORK_INTERFACE__NODE:
				if (resolve) return getNode();
				return basicGetNode();
			case DNIPackage.NETWORK_INTERFACE__NAME_GENERATED:
				return getName_generated();
			case DNIPackage.NETWORK_INTERFACE__ENTITY_TYPE:
				if (resolve) return getEntityType();
				return basicGetEntityType();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case DNIPackage.NETWORK_INTERFACE__ADDRESSES:
				getAddresses().clear();
				getAddresses().addAll((Collection<? extends EntityAddress>)newValue);
				return;
			case DNIPackage.NETWORK_INTERFACE__NAME:
				setName((String)newValue);
				return;
			case DNIPackage.NETWORK_INTERFACE__DESCRIPTION:
				setDescription((String)newValue);
				return;
			case DNIPackage.NETWORK_INTERFACE__UID:
				setUid((String)newValue);
				return;
			case DNIPackage.NETWORK_INTERFACE__USED_PROTOCOL_STACK:
				setUsedProtocolStack((ProtocolStack)newValue);
				return;
			case DNIPackage.NETWORK_INTERFACE__PERFORMANCE:
				setPerformance((PerformanceNetworkInterface)newValue);
				return;
			case DNIPackage.NETWORK_INTERFACE__NODE:
				setNode((Node)newValue);
				return;
			case DNIPackage.NETWORK_INTERFACE__ENTITY_TYPE:
				setEntityType((NetworkInterfaceType)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case DNIPackage.NETWORK_INTERFACE__ADDRESSES:
				getAddresses().clear();
				return;
			case DNIPackage.NETWORK_INTERFACE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case DNIPackage.NETWORK_INTERFACE__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case DNIPackage.NETWORK_INTERFACE__UID:
				unsetUid();
				return;
			case DNIPackage.NETWORK_INTERFACE__USED_PROTOCOL_STACK:
				setUsedProtocolStack((ProtocolStack)null);
				return;
			case DNIPackage.NETWORK_INTERFACE__PERFORMANCE:
				setPerformance((PerformanceNetworkInterface)null);
				return;
			case DNIPackage.NETWORK_INTERFACE__NODE:
				setNode((Node)null);
				return;
			case DNIPackage.NETWORK_INTERFACE__ENTITY_TYPE:
				setEntityType((NetworkInterfaceType)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case DNIPackage.NETWORK_INTERFACE__ADDRESSES:
				return addresses != null && !addresses.isEmpty();
			case DNIPackage.NETWORK_INTERFACE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case DNIPackage.NETWORK_INTERFACE__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case DNIPackage.NETWORK_INTERFACE__UID:
				return isSetUid();
			case DNIPackage.NETWORK_INTERFACE__UID_GENERATED:
				return UID_GENERATED_EDEFAULT == null ? getUid_generated() != null : !UID_GENERATED_EDEFAULT.equals(getUid_generated());
			case DNIPackage.NETWORK_INTERFACE__USED_PROTOCOL_STACK:
				return usedProtocolStack != null;
			case DNIPackage.NETWORK_INTERFACE__PERFORMANCE:
				return performance != null;
			case DNIPackage.NETWORK_INTERFACE__NODE:
				return basicGetNode() != null;
			case DNIPackage.NETWORK_INTERFACE__NAME_GENERATED:
				return NAME_GENERATED_EDEFAULT == null ? getName_generated() != null : !NAME_GENERATED_EDEFAULT.equals(getName_generated());
			case DNIPackage.NETWORK_INTERFACE__ENTITY_TYPE:
				return entityType != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == NamedElement.class) {
			switch (derivedFeatureID) {
				case DNIPackage.NETWORK_INTERFACE__NAME: return DNIPackage.NAMED_ELEMENT__NAME;
				case DNIPackage.NETWORK_INTERFACE__DESCRIPTION: return DNIPackage.NAMED_ELEMENT__DESCRIPTION;
				default: return -1;
			}
		}
		if (baseClass == Identifier.class) {
			switch (derivedFeatureID) {
				case DNIPackage.NETWORK_INTERFACE__UID: return DNIPackage.IDENTIFIER__UID;
				case DNIPackage.NETWORK_INTERFACE__UID_GENERATED: return DNIPackage.IDENTIFIER__UID_GENERATED;
				default: return -1;
			}
		}
		if (baseClass == Entity.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == NamedElement.class) {
			switch (baseFeatureID) {
				case DNIPackage.NAMED_ELEMENT__NAME: return DNIPackage.NETWORK_INTERFACE__NAME;
				case DNIPackage.NAMED_ELEMENT__DESCRIPTION: return DNIPackage.NETWORK_INTERFACE__DESCRIPTION;
				default: return -1;
			}
		}
		if (baseClass == Identifier.class) {
			switch (baseFeatureID) {
				case DNIPackage.IDENTIFIER__UID: return DNIPackage.NETWORK_INTERFACE__UID;
				case DNIPackage.IDENTIFIER__UID_GENERATED: return DNIPackage.NETWORK_INTERFACE__UID_GENERATED;
				default: return -1;
			}
		}
		if (baseClass == Entity.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", description: ");
		result.append(description);
		result.append(", uid: ");
		if (uidESet) result.append(uid); else result.append("<unset>");
		result.append(')');
		return result.toString();
	}

} //NetworkInterfaceImpl
