package epsilonStandalone;

import com.google.common.base.Objects;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.util.List;
import org.eclipse.epsilon.common.parse.problem.ParseProblem;
import org.eclipse.epsilon.eol.EolModule;
import org.eclipse.epsilon.eol.IEolModule;
import org.eclipse.epsilon.eol.exceptions.EolRuntimeException;
import org.eclipse.epsilon.eol.exceptions.models.EolModelLoadingException;
import org.eclipse.epsilon.eol.execute.context.Variable;
import org.eclipse.epsilon.eol.models.IModel;
import org.eclipse.xtext.xbase.lib.CollectionLiterals;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.InputOutput;

@SuppressWarnings("all")
public class EpsilonBase {
  /**
   * Reads model from file given by URI and applies EOL script and returns the modified model without storing it to the disk
   */
  public static /* EmfModel */Object applyEolScript(final String modelName, final String modelURI, final String metaModelURI, final String eolScriptPath, final List<Variable> eolParameters) {
    throw new Error("Unresolved compilation problems:"
      + "\nThe method createEmfModel(String, String, String, boolean, boolean) from the type EpsilonBase refers to the missing type EmfModel"
      + "\nThe method applyEolScript(EmfModel, String, List<Variable>) from the type EpsilonBase refers to the missing type EmfModel");
  }
  
  /**
   * Applies EOL script on Emf model and returns the modified model without storing it to the disk
   */
  public static /* EmfModel */Object applyEolScript(final /* EmfModel */Object model, final String eolScriptPath, final List<Variable> eolParameters) {
    try {
      EolModule _eolModule = new EolModule();
      EpsilonBase.prepareAndExecute(_eolModule, eolScriptPath, CollectionLiterals.<IModel>newLinkedList(model), eolParameters);
      return model;
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  public static Object applyEtlScript(final /* EmfModel */Object input, final /* EmfModel */Object output, final String etlScriptPath, final List<Variable> eolParameters) {
    throw new Error("Unresolved compilation problems:"
      + "\nType mismatch: cannot convert from EtlModule to IEolModule");
  }
  
  public static String applyEglScript(final /* EmfModel */Object model, final String eglScriptPath, final List<Variable> eglParameters) {
    throw new Error("Unresolved compilation problems:"
      + "\nType mismatch: cannot convert from EglTemplateFactoryModuleAdapter to IEolModule");
  }
  
  /**
   * Executes Epsilon code over models
   */
  private static Object prepareAndExecute(final IEolModule module, final String source, final List<IModel> models, final List<Variable> parameters) throws Exception {
    URI resURI = EpsilonBase.getFileURI(source);
    module.parse(resURI);
    int _size = module.getParseProblems().size();
    boolean _greaterThan = (_size > 0);
    if (_greaterThan) {
      System.err.println("Parse errors occurred...");
      List<ParseProblem> _parseProblems = module.getParseProblems();
      for (final ParseProblem problem : _parseProblems) {
        System.err.println(problem.toString());
      }
      return null;
    }
    for (final IModel model : models) {
      module.getContext().getModelRepository().addModel(model);
    }
    for (final Variable parameter : parameters) {
      module.getContext().getFrameStack().put(parameter);
    }
    Object result = EpsilonBase.execute(module);
    for (final IModel model_1 : models) {
      module.getContext().getModelRepository().removeModel(model_1);
    }
    return result;
  }
  
  private static Object execute(final IEolModule module) throws EolRuntimeException {
    return module.execute();
  }
  
  /**
   * Reads emf model object from file
   */
  public static /* EmfModel */Object readEmfModel(final String name, final String modelURI, final String metamodelURI) throws EolModelLoadingException, URISyntaxException {
    throw new Error("Unresolved compilation problems:"
      + "\nEmfModel cannot be resolved to a type."
      + "\nEmfModel cannot be resolved."
      + "\nThe method or field EmfModel is undefined"
      + "\nThe method or field EmfModel is undefined"
      + "\nThe method or field EmfModel is undefined"
      + "\nThe method or field EmfModel is undefined"
      + "\nThe method or field EmfModel is undefined"
      + "\nPROPERTY_NAME cannot be resolved"
      + "\nPROPERTY_FILE_BASED_METAMODEL_URI cannot be resolved"
      + "\nPROPERTY_MODEL_URI cannot be resolved"
      + "\nPROPERTY_READONLOAD cannot be resolved"
      + "\nPROPERTY_STOREONDISPOSAL cannot be resolved"
      + "\nload cannot be resolved");
  }
  
  /**
   * Creates emf model object if a file addressed over uri does not exist
   */
  public static /* EmfModel */Object createEmfModel(final String name, final String modelURI, final String metamodelURI, final boolean readOnLoad, final boolean storeOnDisposal) throws EolModelLoadingException, URISyntaxException {
    throw new Error("Unresolved compilation problems:"
      + "\nEmfModel cannot be resolved to a type."
      + "\nEmfModel cannot be resolved."
      + "\nThe method or field EmfModel is undefined"
      + "\nThe method or field EmfModel is undefined"
      + "\nThe method or field EmfModel is undefined"
      + "\nThe method or field EmfModel is undefined"
      + "\nThe method or field EmfModel is undefined"
      + "\nPROPERTY_NAME cannot be resolved"
      + "\nPROPERTY_FILE_BASED_METAMODEL_URI cannot be resolved"
      + "\nPROPERTY_MODEL_URI cannot be resolved"
      + "\nPROPERTY_READONLOAD cannot be resolved"
      + "\nPROPERTY_STOREONDISPOSAL cannot be resolved"
      + "\nload cannot be resolved");
  }
  
  public static /* EmfModel */Object createEmfModelByURI(final String name, final String modelURI, final String metamodelURI, final boolean readOnLoad, final boolean storeOnDisposal) throws EolModelLoadingException, URISyntaxException {
    throw new Error("Unresolved compilation problems:"
      + "\nEmfModel cannot be resolved to a type."
      + "\nEmfModel cannot be resolved."
      + "\nThe method or field EmfModel is undefined"
      + "\nThe method or field EmfModel is undefined"
      + "\nThe method or field EmfModel is undefined"
      + "\nThe method or field EmfModel is undefined"
      + "\nThe method or field EmfModel is undefined"
      + "\nPROPERTY_NAME cannot be resolved"
      + "\nPROPERTY_FILE_BASED_METAMODEL_URI cannot be resolved"
      + "\nPROPERTY_MODEL_URI cannot be resolved"
      + "\nPROPERTY_READONLOAD cannot be resolved"
      + "\nPROPERTY_STOREONDISPOSAL cannot be resolved"
      + "\nload cannot be resolved");
  }
  
  public static /* EmfModel */Object createEmfModelByMetaModelURI(final String name, final String model, final String metamodel, final boolean readOnLoad, final boolean storeOnDisposal) throws EolModelLoadingException, URISyntaxException {
    throw new Error("Unresolved compilation problems:"
      + "\nEmfModel cannot be resolved to a type."
      + "\nEmfModel cannot be resolved."
      + "\nThe method or field EmfModel is undefined"
      + "\nThe method or field EmfModel is undefined"
      + "\nThe method or field EmfModel is undefined"
      + "\nThe method or field EmfModel is undefined"
      + "\nThe method or field EmfModel is undefined"
      + "\nPROPERTY_NAME cannot be resolved"
      + "\nPROPERTY_METAMODEL_URI cannot be resolved"
      + "\nPROPERTY_MODEL_URI cannot be resolved"
      + "\nPROPERTY_READONLOAD cannot be resolved"
      + "\nPROPERTY_STOREONDISPOSAL cannot be resolved"
      + "\nload cannot be resolved");
  }
  
  private static URI getFileURI(final String fileName) throws URISyntaxException {
    InputOutput.<String>println(("searching URI for file: " + fileName));
    URI binUri = null;
    URL res = null;
    try {
      res = EpsilonBase.class.getResource(fileName);
    } catch (final Throwable _t) {
      if (_t instanceof Exception) {
        final Exception e = (Exception)_t;
      } else {
        throw Exceptions.sneakyThrow(_t);
      }
    }
    boolean _equals = Objects.equal(res, null);
    if (_equals) {
      try {
        URL _uRL = new URL(fileName);
        res = _uRL;
      } catch (final Throwable _t_1) {
        if (_t_1 instanceof Exception) {
          final Exception e_1 = (Exception)_t_1;
        } else {
          throw Exceptions.sneakyThrow(_t_1);
        }
      }
    }
    boolean _equals_1 = Objects.equal(res, null);
    if (_equals_1) {
      try {
        URL _uRL_1 = new URL(("file:" + fileName));
        res = _uRL_1;
      } catch (final Throwable _t_2) {
        if (_t_2 instanceof Exception) {
          final Exception e_2 = (Exception)_t_2;
        } else {
          throw Exceptions.sneakyThrow(_t_2);
        }
      }
    }
    InputOutput.<String>println(("found resource: " + res));
    binUri = res.toURI();
    InputOutput.<String>println(("binUri: " + binUri));
    URI uri = null;
    int _indexOf = binUri.toString().indexOf("bin");
    boolean _greaterThan = (_indexOf > (-1));
    if (_greaterThan) {
      String _replaceAll = binUri.toString().replaceAll("bin", "src");
      URI _uRI = new URI(_replaceAll);
      uri = _uRI;
    } else {
      uri = binUri;
    }
    InputOutput.<String>println(("\t... resulted in: " + uri));
    return uri;
  }
}
